config/routes.rb
Rails.application.routes.draw do

  match 'registration/start', via: [:get, :post, :put]
  match 'registration/register', via: [:get, :post]
  match 'registration/wei_register', via: [:get, :post]
  get 'registration/questions'
  post 'registration/pay'
  match 'registration/card', via: [:get, :post]
  get 'registration/details'

  ActiveAdmin.routes(self)

  resources :students do
    member do
      patch :card
    end
    resources :memberships, only: [:index]
    resources :payments, only: [:create, :update, :index]
  end

  resources :payments, only: [:index, :logs]
  get 'payments/logs', controller: 'payments', action: 'logs', as: :logs
  get 'payments/stats', controller: 'payments', action: 'stats', as: :trezo_stats

  scope 'wei' do
    resources :wei_registrations do
      member do
        post 'pay', as: :pay
      end
      collection do
        get 'waiting'
        get 'deposit'
        get 'registered'
        get 'unregistered'
        get 'to_refund'
        get 'parental'
      end
    end
    resources :wei_bungalows
    resources :wei_buses
  end

  get 'email/:key' => 'email#show', as: :view_email
  get 'email' => 'email#show' unless Rails.env.production?

  devise_for :users, :controllers => { :omniauth_callbacks => "users/omniauth_callbacks" }

  namespace :api, default: {format: :json}, path: '/api' do
    scope module: :version1 do
      match '*path', :controller => 'api', :action => 'cors', via: [:options]
      get 'auth' => 'api#auth'
      get 'membership' => 'membership#show'
      get 'students' => 'membership#index'
      get 'mass_students' => 'membership#bulk'
    end
  end

  root 'students#index'

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/wei_bungalow.rb
class WeiBungalow < ApplicationRecord

  belongs_to :wei
  belongs_to :wei_bus
  has_many :wei_registrations, -> {registered}
  has_many :students, through: :wei_registrations

  scope :for_current_wei, -> {where(wei: Wei.current)}
  default_scope { for_current_wei.order(:name) }

  scope :not_full, -> {where('wei_registrations_count < seats')}
  scope :for_bus, -> (bus) {includes('wei_bus').where(wei_bus: bus)}

  validates :wei_registrations_count, inclusion: { in: -> (bungalow) {(0..(bungalow.seats))}}

  # Check for mixte half of each

end

app/controllers/wei_bungalows_controller.rb
class WeiBungalowsController < ApplicationController
  before_action :set_wei_bungalow, only: [:show, :edit, :update, :destroy]

  # GET /wei_bungalows
  # GET /wei_bungalows.json
  def index
    @wei_bungalows = WeiBungalow.all
  end

  # GET /wei_bungalows/1
  # GET /wei_bungalows/1.json
  def show
  end

  # GET /wei_bungalows/new
  def new
    @wei_bungalow = WeiBungalow.new
  end

  # GET /wei_bungalows/1/edit
  def edit
  end

  # POST /wei_bungalows
  # POST /wei_bungalows.json
  def create
    @wei_bungalow = WeiBungalow.new(wei_bungalow_params)

    respond_to do |format|
      if @wei_bungalow.save
        format.html { redirect_to @wei_bungalow, notice: 'Wei bungalow was successfully created.' }
        format.json { render :show, status: :created, location: @wei_bungalow }
      else
        format.html { render :new }
        format.json { render json: @wei_bungalow.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /wei_bungalows/1
  # PATCH/PUT /wei_bungalows/1.json
  def update
    respond_to do |format|
      if @wei_bungalow.update(wei_bungalow_params)
        format.html { redirect_to @wei_bungalow, notice: 'Wei bungalow was successfully updated.' }
        format.json { render :show, status: :ok, location: @wei_bungalow }
      else
        format.html { render :edit }
        format.json { render json: @wei_bungalow.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /wei_bungalows/1
  # DELETE /wei_bungalows/1.json
  def destroy
    @wei_bungalow.destroy
    respond_to do |format|
      format.html { redirect_to wei_bungalows_url, notice: 'Wei bungalow was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_wei_bungalow
      @wei_bungalow = WeiBungalow.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def wei_bungalow_params
      params.require(:wei_bungalow).permit(:name, :seats, :gender, :wei_bus_id)
    end
end

app/helpers/wei_bungalows_helper.rb
module WeiBungalowsHelper
end

app/views/wei_bungalows/_form.html.haml
= form_for(wei_bungalow) do |f|

  .row
    .col-md-4{class: [bs_form_error_cl(f,:gender)]}
      .form-group
        = f.label :gender
        = f.select :gender, [%w(Homme M), %w(Femme W), %w(Mixte A)], {}, {class: 'form-control'}
    .col-md-8{class: [bs_form_error_cl(f,:name)]}
      .form-group
        = f.label :name
        = f.text_field :name, class: 'form-control'
        = bs_form_errors(f, :name)
  .row
    .col-md-6{class: [bs_form_error_cl(f,:seats)]}
      .form-group
        = f.label :seats
        = f.select :seats, %w(4 6), {}, {class: 'form-control'}
        = bs_form_errors(f, :seats)
    .col-md-6{class: [bs_form_error_cl(f,:wei_bus)]}
      .form-group
        = f.label :wei_bus_id
        = f.select :wei_bus_id, WeiBus.all.map {|b|[b.name, b.id]} , {}, {class: 'form-control'}
        = bs_form_errors(f, :wei_bus)
  .actions
    = f.submit class:'btn btn-block btn-primary'

app/views/wei_bungalows/edit.html.erb
<h1><%= t('.edit') %></h1>

<%= render 'form', wei_bungalow: @wei_bungalow %>

<%= link_to t('cancel'), wei_bungalows_path, class: %w(btn btn-secondary m-t-1 btn-block) %>

app/views/wei_bungalows/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Wei Bungalows</h1>

<table class="table table-bordered table-hover table-striped">
  <thead>
    <tr>
      <th><%= t('activerecord.attributes.wei_bungalow.gender') %></th>
      <th><%= t('activerecord.attributes.wei_bungalow.name') %></th>
      <th><%= t('activerecord.attributes.wei_bungalow.seats') %></th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @wei_bungalows.each do |wei_bungalow| %>

      <tr>
        <td><%= wei_bungalow.gender %></td>
        <td><%= wei_bungalow.name %></td>
        <td><%= wei_bungalow.seats %></td>
        <td><%= link_to 'Show', wei_bungalow %></td>
        <td><%= link_to 'Edit', edit_wei_bungalow_path(wei_bungalow) %></td>
        <td><%= link_to 'Destroy', wei_bungalow, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to t('wei_bungalows.new.new'), new_wei_bungalow_path, class: %w(btn btn-success m-t-1 btn-block) %>

app/views/wei_bungalows/new.html.erb
<h1><%= t('.new') %></h1>

<%= render 'form', wei_bungalow: @wei_bungalow %>

<%= link_to t('cancel'), wei_bungalows_path, class: %w(btn btn-secondary m-t-1 btn-block) %>

app/views/wei_bungalows/show.html.erb
<p id="notice"><%= notice %></p>

<%= link_to 'Edit', edit_wei_bungalow_path(@wei_bungalow) %> |
<%= link_to 'Back', wei_bungalows_path %>